Framework BRL.Max2D
Import BRL.GLMax2D
Import BRL.Retro
Import BRL.PNGLoader
Import BRL.FreeTypeFont

Type TUnit
Global Sprite:TImage
Field Team%,Char%,Health%=100,Pos:TPoint,SPos:TPoint,Range%=4,Paths:TNode[32,20],Path:TNode,Node:TNode,Moved#,Attacked#
Function Load()
Sprite=LoadAnimImage("graphics/units.png",32,32,0,3)
TNode.Load()
EndFunction 
Function Create:TUnit(team%,char%,x%,y%)
Local c:TUnit=New TUnit
c.Team=team
c.Char=char
c.Pos=TPoint.Create(x,y)
c.SPos=TPoint.Create(x*32,y*32)
Return c
EndFunction
Method Move(x%,y%)
Path=Paths[x,y]
UM[Pos.X,Pos.Y]=Null
Pos=TPoint.Create(x,y)
UM[Pos.X,Pos.Y]=Self
CheckPaths()
Moved=True
EndMethod
Method Attack(target:TUnit)
Local damage#=30+Rnd(10)
If Char-target.Char=-1 Or (Char=2 And target.Char=0)
damage:*1.5
ElseIf Char-target.Char=1 Or (Char=0 And target.Char=2)
damage:*0.5
EndIf
target.Health=Max(target.Health-damage,0)
Local r%=0,g%=0,b%=0
For Local i%=0 To 49
If target.Health>0 r=200 g=100 b=80
TParticle.Create(target.SPos.X+Rnd(32),target.SPos.Y+Rnd(32),Rand(3)-2,Rand(3)-2,r,g,b)
Next
Attacked=1
Moved=1
EndMethod
Method Update()
If Path<>Null And Node=Null
If Path.Parent=Null
Node=Path
Path=Null
Else
Local search:TNode=Path
Local before:TNode=Path
While search.Parent<>Null
before=search
search=search.Parent
Wend
Node=before.Parent
before.Parent=Null
EndIf
EndIf
If Node<>Null
If Node.Pos.X*32<SPos.X SPos.X:-4
If Node.Pos.X*32>SPos.X SPos.X:+4
If Node.Pos.Y*32<SPos.Y SPos.Y:-4
If Node.Pos.Y*32>SPos.Y SPos.Y:+4
If Node.Pos.X*32=SPos.X And Node.Pos.Y*32=SPos.Y Node=Null
EndIf
EndMethod
Method Render(Sx%,Sy%)
Local x%=Sx+SPos.X,y%=Sy+SPos.Y
DrawImage Sprite,x,y,Char
SetColor 0,0,0
x:+32*0.5-TextWidth(Health)*0.5
DrawTextOutline Health,x,y-8
SetColor 80,100,200
If Team=1 SetColor 200,100,80
DrawText Health,x,y-8
SetColor 255,255,255
EndMethod 
EndType 

Type TNode
Global Reflection:TImage,Selection:TImage
Field Pos:TPoint,Parent:TNode,Anim%
Function Create:TNode(parent:TNode,x%,y%)
Local c:TNode=New TNode
c.Parent=parent
c.Pos=TPoint.Create(x,y)
Return c
EndFunction
Function Load()
Reflection=LoadImage("graphics/reflection.png",0)
Selection=LoadImage("graphics/selection.png",0)
EndFunction
Method Render(reflect:Byte,Sx%,Sy%)
Local x%=Pos.X*32
Local y%=Pos.Y*32
SetAlpha 0.5
DrawImage Selection,Sx+x,Sy+y
If reflect
If Parent<>Null Parent.Render(reflect,Sx,Sy)
SetAlpha 0.2
SetColor 255,255,255
Anim:+1
If Anim>=0 Anim:-64
SetViewport Sx+x+2,Sy+y+2,32-4,32-4
TileImage Reflection,Sx+x+anim,Sy+y+anim
SetViewport 0,0,GraphicsWidth(),GraphicsHeight()
EndIf
SetAlpha 1
EndMethod 
EndType 


Type TParticle
Field Pos:TPoint,Vel:TPoint,R%,G%,B%,Life#
Function Create(x%,y%,vx%,vy%,r%,g%,b%)
Local c:TParticle=New TParticle
c.Pos=TPoint.Create(x, y)
c.Vel=TPoint.Create(vx, vy)
c.R=r
c.G=g
c.B=b
Particles.AddLast(c)
EndFunction
Method Update()
Pos.X:+Vel.X
Pos.Y:+Vel.Y
Life:+1
If Life>=40 Particles.Remove(Self)
EndMethod
EndType

Type TPoint
Field X%,Y%
Function Create:TPoint(x%,y%)
Local c:TPoint=New TPoint
c.X=x
c.Y=y
Return c
EndFunction
EndType

Function DrawTextOutline(text$,x%,y%)
SetColor 0,0,0
For Local alpha%=0 To 359 Step 45
DrawText text,x+Sin(alpha),y-Cos(alpha)
Next
EndFunction

Function CheckPaths()
Local unit:TUnit,node:TNode,i%,j%,k%,l%,x%,y%
For i% = 0 To 31
For j% = 0 To 19
unit=UM[i,j]
If unit<>Null
Local nodes:TList=CreateList(),nextnodes:TList=CreateList()
nodes.AddLast(TNode.Create(Null,unit.Pos.X,unit.Pos.Y))
unit.Paths=New TNode[32,20]
For k=0 To unit.Range-1
For node=EachIn nodes
For l=0 To 359 Step 90
x=node.Pos.X+Sin(l)
y=node.Pos.Y-Cos(l)
If FieldIsFree(x,y)
If unit.Paths[x,y]=Null
Local nextnode:TNode=TNode.Create(node, x, y)
unit.Paths[x,y]=nextnode
nextnodes.AddLast(nextnode)
EndIf
EndIf
Next
Next
nodes=nextnodes.Copy()
nextnodes.Clear()
Next
EndIf
Next
Next
End Function

Function FieldIsFree%(x%,y%)
If x<0 Or x>=32 Return 0
If y<0 Or y>=20 Return 0
If TM[x,y]>0 Return 0
If UM[x,y]<>Null Return 0
Return 1
End Function

Function GetTile%(x%,y%)
If x<0 Or x>=32 Return 1
If y<0 Or y>=20 Return 1
Return TM[x,y]
End Function

AppTitle$="Horstcraft I"
SetGraphicsDriver GLMax2DDriver()
Graphics 640,400,0,60
SetBlend ALPHABLEND
SeedRnd MilliSecs()
Global Messages$[]=["Blue's turn","Red's turn","Blue wins!","Red wins!"],Gras:TImage,Water:TImage,TM%[32,20],UM:TUnit[32,20],Particles:TList=CreateList(),WaterMap%[64,40],C:TPoint,PlayersTurn%,SelUnit:TUnit,S:TPoint
Local i%,j%,x%,y%,unit:TUnit,selpath:TNode,alive%=1,map$ = "default.map"
If AppArgs.Dimensions()[0]>1 map=AppArgs[1]
Gras=LoadImage("graphics/gras.png")
Water=LoadAnimImage("graphics/water.png",32*0.5,32*.5,0,32)
TUnit.Load()
Local stream:TStream=ReadStream("maps/"+map)
If stream <> Null
Print "what"
For i=0 To 31
For j=0 To 19
TM[i,j]=stream.ReadByte()
Next
Next
stream.Close()
EndIf
For i=0 To 31
For j=0 To 19
WaterMap[i*2,j*2]=(GetTile(i-1,j)*4+GetTile(i-1,j-1)*2+GetTile(i,j-1))*2
WaterMap[i*2+1,j*2]=(GetTile(i+1,j)*4+GetTile(i+1,j-1)*2+GetTile(i,j-1))*2+1
WaterMap[i*2,j*2+1]=(GetTile(i-1,j)*4+GetTile(i-1,j+1)*2+GetTile(i,j+1))*2+16
WaterMap[i*2+1,j*2+1]=(GetTile(i+1,j)*4+GetTile(i+1,j+1)*2+GetTile(i,j+1))*2+17
Next
Next
For i=0 To 4
For j=0 To 1
Repeat
x=Rnd(16)+16*j
y=Rnd(20)
Until FieldIsFree(x, y)
UM[x, y]=TUnit.Create(j,Rnd(3),x,y)
Next
Next
CheckPaths()

Repeat
S=TPoint.Create(320-(MouseX()/640.0)*1024,200-(MouseY()/400.0)*640)
S.X=Min(S.X,0)
S.Y=Min(S.Y,0)
S.X=Max(S.X,-384)
S.Y=Max(S.Y,-240)
C=TPoint.Create((MouseX()-S.X)/32,(MouseY()-S.Y)/32)
TileImage Gras,S.X,S.Y
If PlayersTurn <=1
If KeyHit(KEY_SPACE)
PlayersTurn=1-PlayersTurn
SelUnit=Null
For i=0 To 31
For j=0 To 19
unit=UM[i,j]
If unit<>Null unit.Moved=0 unit.Attacked=0
Next
Next
EndIf
If MouseHit(MOUSE_RIGHT) And SelUnit<>Null
If SelUnit.Team=PlayersTurn
unit=UM[C.X,C.Y]
If unit<>Null
If SelUnit.Attacked=0
If Abs(SelUnit.Pos.X-unit.Pos.X)+Abs(SelUnit.Pos.Y-unit.Pos.Y) = 1
SelUnit.Attack(unit)
If unit.Health=0 UM[C.X,C.Y]=Null
CheckPaths()
EndIf
EndIf
EndIf
EndIf
EndIf
If MouseHit(MOUSE_LEFT)
If SelUnit<>Null
If SelUnit.Paths[C.X,C.Y]<>Null And SelUnit.Team=PlayersTurn And SelUnit.Moved=False
SelUnit.Move(C.X,C.Y)
Else
SelUnit=UM[C.X,C.Y]
EndIf
Else
SelUnit=UM[C.X,C.Y]
EndIf
EndIf
If alive=0 PlayersTurn:+2
EndIf
selpath=Null
alive=0
If SelUnit<>Null
If SelUnit.Moved=0 And SelUnit.Team=PlayersTurn selpath=SelUnit.Paths[C.X,C.Y]
EndIf
For i=0 To 31
For j=0 To 19
If TM[i,j]>0
For x=0 To 1
For y=0 To 1
SetAlpha 0.4
DrawImage Water,S.X+(i*2+x)*16,S.Y+(j*2+y)*16,WaterMap[i*2+x,j*2+y]
Next
Next
EndIf
SetAlpha 1
unit=UM[i,j]
If unit<>Null
unit.Update()
If unit.Team<>PlayersTurn alive:+1
unit.Render(S.X,S.Y)
EndIf
If SelUnit<>Null
If selpath=Null And SelUnit.Moved=False
SetColor 80,100,200
If SelUnit.Team=1 SetColor 200,100,80
If SelUnit.Paths[i,j]<>Null SelUnit.Paths[i,j].Render(False,S.X,S.Y)
EndIf
EndIf
unit=UM[C.X,C.Y]
If unit<>Null And unit<>SelUnit
SetColor 80,100,200
If unit.Team=1 SetColor 200,100,80
If unit.Moved=False If unit.Paths[i,j]<>Null unit.Paths[i,j].Render(False,S.X,S.Y)
EndIf
SetColor 255,255,255
Next
Next
If selpath<>Null selpath.Render(1,S.X,S.Y)
For Local p:TParticle = EachIn Particles
p.Update()
SetAlpha 1-p.Life/40
SetColor p.R,p.G,p.B
DrawRect S.X+p.Pos.X,S.Y+p.Pos.Y,2+p.Life/4,2+p.Life/4
Next
SetAlpha 1
info$=Messages[PlayersTurn]
DrawTextOutline info,240,16
SetColor 255,255,255
DrawText info,240,16
Flip
Until AppTerminate()
End